'---------
' visuals
'---------

Rem
bbdoc: 
about: 
EndRem
Type Visuals

	Global _instance:Visuals
	
	Field _currentlayer:VLayer

	'------------
	'get instance
	'------------
	
	Rem
	bbdoc: Returns the Visuals singleton instance and creates one if it doesnt exist
	EndRem
	Function getInstance:Visuals()
		If Not Visuals._instance Visuals.Create()
		Return Visuals._instance
	EndFunction
	
	Rem

	bbdoc: Initializes the Visuals kernel

	EndRem

	Function initialize()

		Visuals.Create()

	EndFunction
	
	'------
	'create
	'------

	Rem
	bbdoc: 
	about: 
	EndRem
	Function Create()
		Local ret_:Visuals = New Visuals
			ret_.init()
		Visuals._instance = ret_
	EndFunction
	
	Rem
	bbdoc: 
	about: 
	EndRem
	Method init()
		'..
	EndMethod
	
	'----------
	'accsessors
	'----------
	
	Rem
	bbdoc: Returns the currently used layer for drawing
	EndRem
	Method currentLayer:VLayer()
		Return _currentlayer
	EndMethod
	
	Rem
	bbdoc: Set the layer to be drawn in to a specific
	EndRem
	Method setCurrentLayer( layer_:VLayer )
		_currentLayer = layer_
	EndMethod
	
	'----

	'misc

	'----

	

	Function disableTexture()

		glDisable(GL_TEXTURE_2D)

	EndFunction

	

	Function enableTexture()

		glEnable(GL_TEXTURE_2D)

	EndFunction
	
EndType